﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace XamGridDataBinding
{
     
    public partial class MainPage : UserControl
    {
        ObservableCollection<Worker> workersList;

        public MainPage()
        {
            InitializeComponent();
            workersList = new ObservableCollection<Worker>();
            workersList.Add( new Worker("Peter",22,"QA"));
            workersList.Add( new Worker("Andy",22,"DS"));
            workersList.Add( new Worker("Peter",22,"Dev"));
            this.MyGrid.ItemsSource = workersList;
        }
    }

    public class Person : INotifyPropertyChanged
    {
        public Person()
        {

        }

        public Person(string name,int age)
        {
            this.name = name;
            this.age = age;
        }

        private string name;
        private int age;


        public string Name
        {
            get
            {
                return this.name;
            }

            set
            {
                if (value != this.name)
                {
                    this.name = value;
                    NotifyPropertyChanged("Name");
                }
            }
        }
         
        public int Age
        {
            get
            {
                return this.age;
            }

            set
            {
                if (value != this.age)
                {
                    this.age = value;
                    NotifyPropertyChanged("Age");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }

    public class Worker : Person, INotifyPropertyChanged
    {
        public Worker():base() {}

        public Worker(string name, int age, string job)
            : base(name, age)
        {
            this.JobTitle = job;
        }

        private string jobTitle;

        public string JobTitle
         {
            get
              {
                return this.jobTitle;
              }

            set
             {
                if (value != this.jobTitle)
                {
                    this.jobTitle = value;
                    NotifyPropertyChanged("JobTitle");
                }
             }
         }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

    
    }
}
